/* scheme.h for Chez Scheme Version 6.0a */
/* Copyright (c) 1997 Cadence Research Systems */

/* Do not edit this file.  It is automatically generated and */
/* specifically tailored to the version of Chez Scheme named */
/* above.  Always be certain that you have the correct scheme.h */
/* for the version of Chez Scheme you are using. */

/* Warning: Some macros may evaluate arguments more than once. */

/* Enable function prototypes for standard C. */
#if defined(__STDC__) || defined(USE_ANSI_PROTOTYPES)
#define PROTO(x) x
#else
#define PROTO(x) ()
#endif

/* Scheme objects are represented in C as ints. */
typedef int ptr;

/* Type predicates */
#define Sfixnump(x) (((int)(x)&(0x3))==(0x0))
#define Scharp(x) (((int)(x)&(0xFF))==(0x36))
#define Snullp(x) ((x) == 0x26)
#define Seof_objectp(x) ((x) == 0x16)
#define Sbwp_objectp(x) ((x) == 0x4E)
#define Sbooleanp(x) (((int)(x)&(0xF7))==(0x6))
#define Spairp(x) (((int)(x)&(0x7))==(0x1))
#define Ssymbolp(x) (((int)(x)&(0x7))==(0x3))
#define Sprocedurep(x) (((int)(x)&(0x7))==(0x5))
#define Sflonump(x) (((int)(x)&(0x7))==(0x2))
#define Svectorp(x) ((((int)(x)&(0x7))==(0x7)) &&\
    (((int)(*((ptr *)((int)(x)+1)))&(0x3))==(0x0)))
#define Sstringp(x) ((((int)(x)&(0x7))==(0x7)) &&\
    (((int)(*((ptr *)((int)(x)+1)))&(0x7))==(0x1)))
#define Sbignump(x) ((((int)(x)&(0x7))==(0x7)) &&\
    (((int)(*((ptr *)((int)(x)+1)))&(0x6))==(0x2)))
#define Sboxp(x) ((((int)(x)&(0x7))==(0x7)) &&\
    ((*((ptr *)((int)(x)+1))) == 0x9E))
#define Sinexactnump(x) ((((int)(x)&(0x7))==(0x7)) &&\
    ((*((ptr *)((int)(x)+1))) == 0x96))
#define Sexactnump(x) ((((int)(x)&(0x7))==(0x7)) &&\
    ((*((ptr *)((int)(x)+1))) == 0xBE))
#define Sratnump(x) ((((int)(x)&(0x7))==(0x7)) &&\
    ((*((ptr *)((int)(x)+1))) == 0x86))
#define Sinputportp(x) ((((int)(x)&(0x7))==(0x7)) &&\
    (((int)(*((ptr *)((int)(x)+1)))&(0x1FF))==(0x1A6)))
#define Soutputportp(x) ((((int)(x)&(0x7))==(0x7)) &&\
    (((int)(*((ptr *)((int)(x)+1)))&(0x2FF))==(0x2A6)))

/* Accessors */
#define Sfixnum_value(x) ((x)/4)
#define Schar_value(x) ((x)>>8)
#define Sboolean_value(x) ((x) != Sfalse)
/* +0 in lines below prevents inappropriate use as lvalues. */
#define Scar(x) (*((ptr *)((int)(x)+7))+0)
#define Scdr(x) (*((ptr *)((int)(x)+11))+0)
#define Ssymbol_to_string(x) (*((ptr *)((int)(x)+17))+0)
#define Sflonum_value(x) *((double *)((int)(x)+6))
#define Svector_length(x) ((int)*((ptr *)((int)(x)+1))>>2)
#define Svector_ref(x, i) (((ptr *)((int)(x)+5))[i])
#define Sstring_length(x) ((int)*((ptr *)((int)(x)+1))>>3)
#define Sstring_ref(x, i) (Sstring_value(x)[i])
/* Warning: Sstring_value(x) returns a pointer into x. */
#define Sstring_value(x) ((char *)((int)(x)+5))
#define Sunbox(x) (*((ptr *)((int)(x)+5))+0)
extern int Sinteger_value PROTO((ptr));
#define Sunsigned_value(x) (unsigned)Sinteger_value(x)

/* Mutators */
extern void Sset_box PROTO((ptr, ptr));
extern void Sset_car PROTO((ptr, ptr));
extern void Sset_cdr PROTO((ptr, ptr));
#define Sstring_set(x, i, c) ((void)(Sstring_value(x)[i] = (c)))
extern void Svector_set PROTO((ptr, int, ptr));

/* Constructors */
#define Sfixnum(x) ((x)<<2)
#define Schar(x) (((x)&0xFF)<<8|0x36)
#define Snil (0x26)
#define Strue (0xE)
#define Sfalse (0x6)
#define Sboolean(x) ((x)?Strue:Sfalse)
#define Sbwp_object (0x4E)
#define Seof_object (0x16)
#define Svoid (0x3E)
extern ptr Scons PROTO((ptr, ptr));
extern ptr Sstring_to_symbol PROTO((char *));
extern ptr Sflonum PROTO((double));
extern ptr Smake_vector PROTO((int, ptr));
extern ptr Smake_string PROTO((int, char));
extern ptr Smake_uninitialized_string PROTO((int));
extern ptr Sstring PROTO((char *));
extern ptr Sstring_of_length PROTO((char *, int));
extern ptr Sbox PROTO((ptr));
extern ptr Sinteger PROTO((int));
extern ptr Sunsigned PROTO((unsigned));

/* Miscellaneous */
extern ptr Stop_level_value PROTO((ptr));
extern void Sset_top_level_value PROTO((ptr, ptr));
extern void Slock_object PROTO((ptr));
extern void Sunlock_object PROTO((ptr));
extern void Sforeign_symbol PROTO((char *, int));

/* Support for calls into Scheme */
extern ptr Scall0 PROTO((ptr));
extern ptr Scall1 PROTO((ptr, ptr));
extern ptr Scall2 PROTO((ptr, ptr, ptr));
extern ptr Scall3 PROTO((ptr, ptr, ptr, ptr));
extern void Sinitframe PROTO((int));
extern void Sput_arg PROTO((int, ptr));
extern ptr Scall PROTO((ptr, int));
